# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 MSF, TeMPO Consulting.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from report import report_sxw
from spreadsheet_xml.spreadsheet_xml_write import SpreadsheetReport
import pooler

class report_fully_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(report_fully_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'getInvoiceLines': self.getLines,
        })
        return

    def getLines(self, invoice_ids):
        """
        Fetch invoice lines and tax lines (if exists)
        """
        # Prepare some value
        res = []
        # Do not check lines if no invoice given
        if not invoice_ids:
            return res
        if isinstance(invoice_ids, (int, long)):
            invoice_ids = [invoice_ids]
        for invoice in pooler.get_pool(self.cr.dbname).get('account.invoice').browse(self.cr, self.uid, invoice_ids):
            if invoice.invoice_line:
                res += [x for x in invoice.invoice_line]
            if invoice.tax_line:
                res += [x for x in invoice.tax_line]
        return res

SpreadsheetReport('report.fully.report','account.bank.statement','addons/register_accounting/report/fully_report_xls.mako', parser=report_fully_report)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
